C   (0,1) * (0,1) is divided into procx * procy subdomains 
C   numbered row by row,
C   according to myid, the array neigh contains the id's
C   of the neighbors at South, East, North, West
C   
C	IN:  	myid	  process id
C		procx	  number of subdomains in x-direction
C		procy	  number of subdomains in x-direction
C	OUT     neigh     id's of neighbors
C		color     black/white coloring (check board) of subdomains   	


	SUBROUTINE IniGeom(myid,procx,procy,neigh,color)

	IMPLICIT NONE
	INTEGER   myid,procx,procy,neigh,color, kx,ky
	DIMENSION neigh(4)

	kx = MOD(myid,procx)			! column
	ky = myid/procx				! row
C					South
	IF (ky.EQ.0) THEN
	   neigh(1) = -1
	 ELSE
	   neigh(1) = myid-procx
	ENDIF
C					East
	IF (kx.EQ.procx-1) THEN
	   neigh(2) = -1
	 ELSE
	   neigh(2) = myid+1
	ENDIF
C					North
	IF (ky.EQ.procy-1) THEN
	   neigh(3) = -1
	 ELSE
	   neigh(3) = myid+procx
	ENDIF
C					West
	IF (kx.EQ.0) THEN
	   neigh(4) = -1
	 ELSE
	   neigh(4) = myid-1
	ENDIF
C					Determine the process color
C					Red = 0   or  Black = 1
	color = MOD(kx+ky,2)
	
	RETURN
	END
