/* ********************************************************************	*/
/*				S L A V E				*/
/* ********************************************************************	*/
#include <stdio.h>
#include "mpi.h"

void calc_slave(myid,num,icomm)
int myid,num;
MPI_Comm icomm;
{
 int	maxlength,length,tag,i;
 double	*data,s;
 MPI_Status stat;

/*		Receive maximal length of messages			*/
 MPI_Bcast(&maxlength,1,MPI_INT,0,icomm);
 data = (double*)malloc(maxlength*sizeof(double));

/*		Receive first data set					*/

 tag = 1111;
 MPI_Recv(data, maxlength, MPI_DOUBLE, 0, tag, icomm, &stat);
 MPI_Get_count(&stat, MPI_DOUBLE, &length); 

 while (length>0)
 {
/*		Arithmetic work						*/
   s = 0;
   for (i=0; i<length; i++)  s += data[i]; 

/* 		Send result						*/
   tag = 2222;
   MPI_Send(&s,1,MPI_DOUBLE,0,tag,icomm);

/*		Get new data						*/
   tag = 3333;
   MPI_Recv(data, maxlength, MPI_DOUBLE, 0, tag, icomm, &stat);
   MPI_Get_count(&stat, MPI_DOUBLE, &length); 
 
 }
 
  MPI_Barrier(icomm);
}
