
C	Bestimmt Min und Max (incl. Indizes) des Feldes x	

	SUBROUTINE MinMaxD(n,x,min,kmin,max,kmax,icomm)

	IMPLICIT NONE
	INCLUDE "mpif.h"
	INTEGER n,kmin,kmax,icomm,i
	DOUBLE PRECISION x(*), min, max
 
 	max = x(1)
	min = x(1)
 	kmax = 1
	kmin = 1

	DO i=2,n
	  IF(x(i).GT.max) THEN
	    max = x(i)
	    kmax = i
	  ENDIF
	  IF(x(i).LT.min) THEN
	    min = x(i)
	    kmin = i
	  ENDIF
	END DO

	RETURN
	END

C	Exchange glob. Min. and Max. of a vector 

	SUBROUTINE PivotD(n,x,icomm)

	IMPLICIT NONE
	INCLUDE "mpif.h"
	INTEGER n,icomm
	DOUBLE PRECISION x(*)
C	mm[1] - loc. minimum ,  mm[2] - loc. maximum	
C	km : local indices			
C	gm[1] - glob. minimum , gm[2] - glob. maximum
C	gmid : process-id with min/max		

	INTEGER ierr, km(2), gmid(2), root, numprocs, myid, i,maxbuf
	PARAMETER (maxbuf=200)
	DOUBLE PRECISION mm(2), gm(2), mg(maxbuf), tt
	INTEGER stat(MPI_STATUS_SIZE)

	root = 0
 	CALL MPI_Comm_rank(icomm,myid,ierr)

C	local min/max
 	CALL MinMaxD(n,x,mm(1),km(1),mm(2),km(2),icomm)	
	CALL MPI_Comm_size(icomm,numprocs,ierr)
C	require aux array
	IF(myid.EQ.root) THEN
	  IF(2*numprocs.GT.maxbuf) 
     &			WRITE(*,*) 'Auxiliary array too small !' 
	ENDIF

 	CALL MPI_Gather(mm,2,MPI_DOUBLE_PRECISION,mg,2,
     &		MPI_DOUBLE_PRECISION,
     &       	root,icomm,ierr)

	IF(myid.EQ.root) THEN
	  gm(1) = mg(1)
	  gmid(1) = 0
	  gm(2) = mg(2)
	  gmid(2) = 0
	  DO i=2,numprocs
	    IF(mg(2*i-1).LT.gm(1)) THEN
	      gm(1) = mg(2*i-1)
	      gmid(1) = i-1
	    ENDIF
	    IF(mg(2*i).GT.gm(2)) THEN
	      gm(2) = mg(2*i)
	      gmid(2) = i-1
	    ENDIF
	  ENDDO
	ENDIF
C	Broadcast the processes with Min or Max	

 	CALL MPI_Bcast(gmid,2,MPI_INTEGER,root,icomm,ierr)
C	gmid(1) and gmid(2)  exchange the Min or Max, resp.
	
 	IF(gmid(1).EQ.gmid(2). AND .myid.EQ.gmid(1)) THEN
	  tt = x(km(1))
	  x(km(1)) = x(km(2))
	  x(km(2)) = tt
	  GOTO 999
	ENDIF


	IF(myid.EQ.gmid(1)) THEN
   	  CALL MPI_Send(x(km(1)),1,MPI_DOUBLE_PRECISION,gmid(2),0,icomm,
     &		ierr)
   	  CALL MPI_Recv(x(km(1)),1,MPI_DOUBLE_PRECISION,gmid(2),1,icomm,
     &		stat,ierr)
 	ENDIF

	IF(myid.EQ.gmid(2)) THEN
	  tt = x(km(2)) 
   	  CALL MPI_Recv(x(km(2)),1,MPI_DOUBLE_PRECISION,gmid(1),0,icomm,
     &		stat,ierr)
   	  CALL MPI_Send(tt,1,MPI_DOUBLE_PRECISION,gmid(1),1,icomm,ierr)
	ENDIF 

999	CONTINUE
	
	RETURN
	END
